;IP2Location v1.0 del 26/06/06
;2006 All Right Reserved
;Written by |Wolf|
;http://wolfprojects.altervista.org/

dialog ip2loc {
  title "IP2Location"
  size -1 -1 254 173
  combo 1, 2 3 250 20
  button "Find Location", 2, 2 25 210 20, default
  button "P", 3, 212 25 20 20
  button "#", 20, 232 25 20 20
  box "", 4, 2 41 250 130
  text "IP Address:", 5, 10 53 60 15
  edit "", 6, 70 51 175 20, read autohs
  text "Country:", 7, 10 72 60 15
  edit "", 8, 70 70 175 20, read autohs
  text "Region:", 9, 10 91 60 15
  edit "", 10, 70 89 175 20, read autohs
  text "City:", 11, 10 110 60 15
  edit "", 12, 70 108 175 20, read autohs
  text "ISP:", 13, 10 129 60 15
  edit "", 14, 70 127 175 20, read autohs
  text "Credits:", 15, 10 148 40 15
  edit "", 16, 70 146 30 20, read autohs
  text "Flag:", 17, 110 148 22 15
  icon 18, 140 150 18 12, $mircexe, 15, noborder
  button "Close", 21, 194 146 50 20, cancel
  link "", 19, 167 148 20 15
}

on *:load: {
  if ($input(IP2Location v1.0 del 26/06/06 $crlf $+ 2006 All Right Reserved $crlf $+ Written by |Wolf| $&
    $crlf $+ Scrivere /ip2loc per aprire la dialog. $crlf $+ Aprire il readme?,yi,IP2Location caricato)) {
    .timerip 1 1 run $+(",$scriptdir,ip2locreadme.txt,")
  }
  if ($version < 6.17) {
    .echo -q $input(Per poter visualizzare correttamente le immagini usate da IP2Location  necessario aggiornare $&
      mIRC alla versione 6.17 o superiore.,ow,Warning)
  }
  ip2loc
}

on *:dialog:ip2loc:sclick:2,3: { 
  if ($did == 3) {
    did -ra ip2loc 1 $cb
    did -c ip2loc 1 1
  }
  if ((*.*.*.* iswm $did(1)) && ($count($did(1),.) == 3) && ($remove($did(1),.) isnum) && ($gettok($did(1),1,46) < 256) $&
    && ($gettok($did(1),2,46) < 256) && ($gettok($did(1),3,46) < 256) && ($gettok($did(1),4,46) < 256)) {
    sockclose ip2loc
    dialog -t ip2loc IP2Location - Opening Sock...
    sockopen ip2loc www.ip2location.com 80 
    set %ip.ticks $ticks
  }
  else {
    .echo -q $input(Error: l'indirizzo IP deve essere nel formato xxx.xxx.xxx.xxx (0 <= xxx <= 255),ow,Error)
  }
}

on *:dialog:ip2loc:sclick:19: { 
  url -n %ip.map
}

on *:dialog:ip2loc:sclick:20: { 
  did -r ip2loc 1,6,8,10,12,14,19
  did -g ip2loc 18 15 $+(",$mircexe,")
  dialog -t ip2loc IP2Location
}

on *:dialog:ip2loc:sclick:21: { 
  unset %ip.map 
  dialog -x ip2loc ip2loc
  if ($exists($+(",$scriptdir,flag.gif,"))) {
    .remove $+(",$scriptdir,flag.gif,")
  }
}

on *:dialog:ip2loc:close:0: {
  unset %ip.map 
  if ($exists($+(",$scriptdir,flag.gif,"))) {
    .remove $+(",$scriptdir,flag.gif,")
  }
}


alias ip2loc {
  if (!$dialog(ip2loc)) {
    dialog -m ip2loc ip2loc
  }
}

alias -l nohtml {
  var %x, %i = $regsub($1-,/(^[^<]*>|<[^>]*>|<[^>]*$)/g,$null,%x), %x = $remove(%x,&nbsp;)
  return %x
}


on *:sockopen:ip2loc:{
  var %s = sockwrite -n $sockname,%p = ipaddresses= $+ $did(ip2loc,1)
  %s POST /free.asp HTTP/1.0 
  %s Host: www.ip2location.com 
  %s Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, */*
  %s Content-Type: application/x-www-form-urlencoded 
  %s Content-Length: $len(%p) 
  %s Connection: Close 
  %s Cache-Control: no-cache 
  %s | sockwrite $sockname %p
  dialog -t ip2loc IP2Location - Reading...
}

on *:sockread:ip2loc: {
  if ($sockerr) {
    sockclose ip
    echo $color(info) -st Error: Unable to connect
    return
  }
  else {
    var %ip
    sockread %ip
    if (lookups isin %ip) {
      if ($gettok($gettok(%ip,2,46),3,32) > 0) {
        did -ra ip2loc 16 $calc($gettok($gettok(%ip,2,46),3,32) - 1)
      }
      else {
        did -ra ip2loc 16 0
      }
    }
    if (&nbsp;Map&nbsp; isin %ip) {
      sockread -f %ip

      if (Unable to lookup isin %ip) {
        sockclose ip2loc
        did -r ip2loc 1,6,8,10,12,14,19
        did -g ip2loc 18 15 $+(",$mircexe,")
        dialog -t ip2loc IP2Location - Error: no credits left
        unset %ip.ticks %ip.flag
        return
      }

      set %ip.map
      sockread -f %ip.map
      var %ip.br $calc(200 - $sockbr)
      var %ip.zero 5
      while ((%ip.br > 0) && (%ip.zero)) {
        sockread %ip.br &ip
        %ip.br = $calc(%ip.br - $sockbr)
        %ip.map = %ip.map $bvar(&ip,1,$bvar(&ip,0)).text
        dec %ip.zero
      }

      var %ip.msg $remove($nohtml($replace(%ip,</td>,|)),$chr(13),$chr(10))
      did -ra ip2loc 6 $gettok(%ip.msg,1,124)
      did -ra ip2loc 8 $iif($gettok(%ip.msg,2,124) != -,$ifmatch - $gettok(%ip.msg,3,124),-)
      did -ra ip2loc 10 $gettok(%ip.msg,4,124)
      did -ra ip2loc 12 $gettok(%ip.msg,5,124)
      did -ra ip2loc 14 $gettok(%ip.msg,6,124)

      if (http isin $gettok(%ip.map,2,34)) {
        set %ip.map $replace($gettok(%ip.map,2,34),$chr(32),$chr(37) $+ 20)
        did -ra ip2loc 19 Map
      }
      else {
        did -r ip2loc 19
      }
      sockclose ip2loc

      set %ip.flag $gettok($replace(%ip,img src=,|,></img>,|),2,124)
      if ((/flags/*.gif iswm %ip.flag) && ($version >= 6.17) && (%ip.flag != /flags/-.gif)) {
        dialog -t ip2loc IP2Location - Downloading flag...
        sockopen ip2locflag www.ip2location.com 80
      }
      else {
        dialog -t ip2loc IP2Location - Done: $calc(($ticks - %ip.ticks) / 1000) $+ s
        unset %ip.ticks %ip.flag
        did -g ip2loc 18 15 $+(",$mircexe,")
        return
      }
    }
  }
}


on *:sockopen:ip2locflag:{
  sockwrite -n $sockname GET %ip.flag HTTP/1.0 
  sockwrite -n $sockname Host: www.ip2location.com $+ $crlf $+ $crlf
}

on *:sockread:ip2locflag: {
  if ($sockerr) {
    sockclose ip2locflag
    unset %ip.flag
    echo $color(info) -st Error: Unable to connect
    return
  }

  sockread &flag

  if ($bvar(&flag,1,15).text == HTTP/1.1 200 OK) {
    var %flag.size $gettok($bvar(&flag,$calc($bfind(&flag,0,Content-Length:) + 15),36).text,1,13)
    bcopy -z &flag 1 &flag $calc($bvar(&flag,0) - %flag.size + 1) -1
    bwrite $+(",$scriptdir,flag.gif,") 0 &flag
    did -g ip2loc 18 $+(",$scriptdir,flag.gif,")
  }
  else {
    did -g ip2loc 18 15 $+(",$mircexe,")
  }

  dialog -t ip2loc IP2Location - Done: $calc(($ticks - %ip.ticks) / 1000) $+ s
  unset %ip.ticks %ip.flag
}
